<%
const oneline = option.oneline || false
const toStr = option.toStr || false

let code = ""
switch (typeof value) {
  case 'string':
    code = `'${value}'`
    break
  case 'number':
    if (toStr) {
      code = `'${value.toString()}'`
    } else {
      code = value.toString()
    }
    break
  case 'boolean':
    if (toStr) {
      code = value ? "'true'" : "'false'"
    } else {
      code = value ? "true" : "false"
    }
    break
  case 'undefined':
    // if (toStr) {
    //   code = "'undefined'"
    // } else {
      code = "undefined"
    // }
    break
  case 'object':
    if (value === null) {
      if (toStr) {
        code = "'null'"
      } else {
        code = "null"
      }
    } else if (Array.isArray(value)) {
      const items = value.map((v, i) => include("./index.ejs", {value: v, option})).join(', ')
      if (items) {
        if (oneline || (!items.startsWith("{") && !items.startsWith("["))) {
          code = '[' + items + ']'
        } else {
          code = '[\n' +  _.code.addIndent(items, { indentStr: '  ', nonIndentEmptyLine: true }) + '\n]'
        }
      } else {
        code = "[]"
      }
    } else {
      const properties = Object.getOwnPropertyNames(value)
        .map(propertieName => {
          const _name = propertieName.match(/^[a-zA-Z0-9]+$/) ? propertieName : `'${propertieName}'`
          const _val = include("./index.ejs", {value: value[propertieName], option})
          return _name + ': ' + _val
        }).join(oneline ? ', ' : ',\n')
      if (properties) {
        if (oneline) {
          code = '{ ' + properties + ' }'
        } else {
          code = '{\n' + _.code.addIndent(properties, { indentStr: '  ', nonIndentEmptyLine: true }) + '\n}'
        }
      } else {
        code = "{}"
      }
    }
    break
  case 'function':
    code = value()
    break
  default:
    throw new Error()
}
-%>
<%- code %>